<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY copy "&#169;">
<!ENTITY nbsp "&#160;">
<!ENTITY lk "/webcenter_page/user_lang_key">
]>

<!--                                                                          -->
<!--  This stylesheet contains all sort of common XSL templates that are      -->
<!--  reused all over WebCenter.                                              -->
<!--                                                                          -->

<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	xmlns:fo="http://www.w3.org/1999/XSL/Format" 
	xmlns:java="http://xml.apache.org/xslt/java" 
	xmlns:Math="java.lang.Math" 
	xmlns:VersionUtils="com.esko.webcenter.util.VersionUtils"
	xmlns:WcrStaticUtils="com.esko.webcenter.utils.WcrStaticUtils"
	xmlns:XSLUtils="com.esko.webcenter.jsp.XSLUtils" 
	xmlns:Lang="com.esko.webcenter.jsp.LanguageMgr"
	exclude-result-prefixes="java Math fo XSLUtils VersionUtils WcrStaticUtils Lang">
	
	
	<!-- 

            template that controls the inclusion of a glowing divider
            a three pixel divider with a colored pixel between white pixels. 
            
  -->
	<xsl:template name="glowdivider">
		<tr>
			<td width="100%" class="white_background">
				<img border="0" src="images/clearpixel.gif" alt="" width="1" height="1"/>
			</td>
		</tr>
		<tr>
			<td width="100%" class="esko_grey_background">
				<img border="0" src="images/clearpixel.gif" alt="" width="1" height="1"/>
			</td>
		</tr>
		<tr>
			<td width="100%" class="white_background">
				<img border="0" src="images/clearpixel.gif" alt="" width="1" height="1"/>
			</td>
		</tr>
	</xsl:template>
	<!-- 
  
            template that controls the inclusion of a small grey row,
            followed by a glowing divider and a small white row.
            
  -->
	<xsl:template name="greyoverwhitedivider">
		<tr>
			<td class="white_background" width="100%">
				<img border="0" src="images/clearpixel.gif" alt="" width="1" height="6"/>
			</td>
		</tr>
		<xsl:call-template name="glowdivider"/>
		<tr>
			<td width="100%">
				<img border="0" src="images/clearpixel.gif" alt="" width="1" height="10"/>
			</td>
		</tr>
	</xsl:template>


	<xsl:template name="skinnyGreenRow">
		<tr>
			<td class="esko_green_background" height="1">
				<img height="1" src="images/clearpixel.gif" width="1"/>
			</td>
		</tr>
	</xsl:template>

	<xsl:template name="skinnyGrayRow">
		<tr>
			<td class="grey2_background" height="1">
			</td>
		</tr>
	</xsl:template>

	<xsl:template name="skinnyEskoGrayRow">
		<tr>
			<td class="grey2_background" height="1">
			</td>
		</tr>
	</xsl:template>

	<xsl:template name="spaceWidthClearImage">
		<img border="0" src="images/clearpixel.gif" alt="" width="10" height="1"/>
	</xsl:template>

	<!-- 
  
            template that controls filter area of the page 
            
  -->
	<xsl:template name="filter">
		<xsl:param name="title"/>
		<!-- A text before filter field -->
		<xsl:param name="actionuri"/>
		<!-- name of the page on form -->
		<xsl:param name="actionval"/>
		<!-- An action value used on submitting a form -->
		<xsl:param name="filtervalue"/>
		<!-- A value of filter field -->
		<xsl:param name="clipped"/>
		<xsl:param name="fullCnt"/>
		<xsl:param name="clippedCnt"/>
		<xsl:param name="putInCenter" select="false()"/>
		<!-- align the form in left/center -->
		<xsl:param name="useForm" select="true()"/>
		<!-- create filter in a separate form -->
		<xsl:param name="onClickAction" select="'MM_filter()'"/>
		<!-- default action on "Go" button -->
		<!-- put the show all checkbox here -->
		<xsl:param name="showAllCheckBox" select="false ()"/>
		<!-- when the list is truncated, you want to show the show all checkbox? -->
		<xsl:param name="showAllAction" select="''"/>
		
		<xsl:param name="tr_id" select="''"/>
		<!-- create filter in a separate form -->

		<tr>
			<td width="100%" class="white_background" height="5">
				<img border="0" src="images/clearpixel.gif" alt="" width="1" height="1"/>
			</td>
		</tr>
		<tr>
			<xsl:if test="string-length($tr_id) > 0">
				<xsl:attribute name="id" ><xsl:value-of select="$tr_id"/></xsl:attribute>
			</xsl:if>
			<td>
				<xsl:if test="$useForm">
					<xsl:text disable-output-escaping="yes">&lt;</xsl:text>form name="filterform" method="post" action="<xsl:value-of select="$actionuri"/>"
					<xsl:text disable-output-escaping="yes">&gt;</xsl:text>
					<input type="hidden" name="actionVal" value="{$actionval}"/>
				</xsl:if>
				<table width="100%" border="0" cellpadding="0" cellspacing="0">
					<xsl:call-template name="filterHiddenInputs"/>
				    <!--  propagate the menu_file parameter -->
					<xsl:call-template name="menuFileHiddenInput" />
					
					<input type="hidden" name="filteraction" value=""/>
					<tr class="white_background">
						<xsl:if test="$putInCenter = true()">
							<xsl:attribute name="align">center</xsl:attribute>
						</xsl:if>
						<xsl:if test="$putInCenter = false()">
							<xsl:call-template name="AddWhiteWidth">
								<xsl:with-param name="widthSpace" select="'85'"/>
							</xsl:call-template>
						</xsl:if>
						<td class="filter">
							<xsl:if test="$putInCenter = true()">
								<xsl:attribute name="colspan">2</xsl:attribute>
							</xsl:if>
							<img src="images/clearpixel.gif" alt="" width="10" height="1"/>
							<xsl:value-of select="$title"/>
							<img src="images/clearpixel.gif" alt="" width="10" height="1"/>
							<input name="filtervalue" type="text" class="filter_textinput">
								<xsl:attribute name="value"><xsl:value-of select="$filtervalue"/></xsl:attribute>
							</input>
							<img src="images/clearpixel.gif" alt="" width="10" height="1"/>
							<input type="submit" name="Go" value="{Lang:getStr(&lk;,'GO')}" class="buttonsecondary" onClick="{$onClickAction}"/>
							<!--
			  <img src="images/clearpixel.gif" alt="" width="10" height="1"/>
              <input type="submit" name="clearfilters" value="{Lang:getStr(&lk;,'SHOWALL')}" class="buttonsecondary" onClick="MM_showAll()"/>
			  -->
						</td>
					</tr>
					<xsl:if test="$clipped&gt;0">
						<!-- vertical space -->
						<tr class="white_background">
							<td align="left" class="darktext_greenlink_11" colspan="2">
								<img src="images/clearpixel.gif" width="1" height="5"/>
							</td>
						</tr>
			
						<tr class="clipping_warning">
							<xsl:call-template name="AddWhiteWidth">
								<xsl:with-param name="widthSpace" select="'85'"/>
							</xsl:call-template>
							<td>
								<img src="images/clearpixel.gif" alt="" width="10" height="1"/>
								<xsl:value-of select="Lang:getStr(&lk;,'ITEM_LIST_CLIPPED')"/>&nbsp;<xsl:value-of select="Lang:getStr(&lk;,'FROM')"/>&nbsp;<xsl:value-of select="$fullCnt"/>&nbsp;<xsl:value-of select="Lang:getStr(&lk;,'TO')"/>&nbsp;<xsl:value-of select="$clippedCnt"/>.
							</td>
						</tr>
					</xsl:if>

				</table>
				<xsl:if test="$useForm">
					<xsl:text disable-output-escaping="yes">&lt;</xsl:text>/form <xsl:text disable-output-escaping="yes">&gt;</xsl:text></xsl:if>
				<!--</form> -->
			</td>
		</tr>

		<!-- 'Show all' check box  -->
		<xsl:if test=" ($clipped&gt;0) and ( $showAllCheckBox = true()) ">

			<!-- vertical space -->
			<tr class="white_background">
				<td align="left" class="darktext_greenlink_11">
					<img src="images/clearpixel.gif" width="1" height="5"/>
				</td>
			</tr>

			<tr class="white_background">
				<td align="left" class="darktext_greenlink_11">
					<form name="showall" method="post">
						<xsl:attribute name="action">
							<xsl:value-of select="$showAllAction"/>
						</xsl:attribute>
						<img src="images/clearpixel.gif" width="92" height="0"/>
						<input type="checkbox" name="showall" id="showall" onclick="submit()"/>
					<xsl:value-of select="Lang:getStr(&lk;,'SHOW_ALL')"/>
					</form>
				</td>
			</tr>
		</xsl:if>


		<tr>
			<td width="100%" class="white_background" height="5">
				<img border="0" src="images/clearpixel.gif" alt="" width="1" height="1"/>
			</td>
		</tr>
		<!--   <tr><td width="100%" class="esko_grey_background"><img border="0" src="images/clearpixel.gif" alt="" width="1" height="1"/></td></tr> -->
	</xsl:template>

	<xsl:template name="filterHiddenInputs"/>

	<!--
	No filter specified. Display a message	
-->
	<xsl:template name="SpecifyFilterMessage">
		<xsl:param name="message"/>
		<table width="100%">
			<tr>
				<td>
					<img src="images/clearpixel.gif" width="1" height="30"/>
				</td>
			</tr>
			<tr align="center">
				<td align="center" class="setfiltermessage">
					<img src="images/clearpixel.gif" alt="" width="10" height="1"/>
					<strong>
						<xsl:value-of select="$message"/>
					</strong>
				</td>
			</tr>
		</table>
	</xsl:template>
	
	
	
	<xsl:template name="quickfilter">
		<xsl:param name="title"/>
		<!-- A text before filter field -->
		<xsl:param name="actionuri"/>
		<!-- name of the page on form -->
		<xsl:param name="actionval"/>
		<!-- An action value used on submitting a form -->
		<xsl:param name="filtervalue" select="'filtervalue'"/>
		<!-- A value of filter field -->
		<xsl:param name="putInCenter" select="false()"/>
		<!-- align the form in left/center -->
		<xsl:param name="useForm" select="true()"/>
		<!-- create filter in a separate form -->
		<xsl:param name="onClickAction" select="'MM_filter()'"/>
		<!-- default action on "Go" button -->
		<xsl:param name="tr_id" select="''"/>
		<!-- create filter in a separate form -->
		
		<!-- id for input field of filter -->
		<xsl:param name="filterInputId" select="''"/>
		<xsl:param name="filterInputName" select="'filtervalue'"/>
		
		<!-- if advanced filter options are present -->
		<xsl:param name="hasMoreFilterOptions" select="false()"/>
		<xsl:param name="showFilterButtonDataTarget"/>
		
		
				
		<div class="quick-filter">
			<xsl:if test="string-length($tr_id) > 0">
				<xsl:attribute name="id" ><xsl:value-of select="$tr_id"/></xsl:attribute>
			</xsl:if>
			
			
			
			<xsl:if test="$hasMoreFilterOptions">
				<a class="btn btn-default filter-toggle" data-toggle="collapse" aria-expanded="true">
					<xsl:attribute name="title"><xsl:value-of select="Lang:getStr(&lk;,'SHOW_HIDE_FILTERS')"/></xsl:attribute>
					<xsl:attribute name="data-target"><xsl:value-of select="$showFilterButtonDataTarget"/></xsl:attribute>
					<i class="icon icon-normal icon-WCR_Filter12"></i>
				</a>
			</xsl:if>
			
			
			<xsl:choose>
				<xsl:when test="$useForm">
					<form name="filterform" method="post" class="wcr-form">
						<xsl:attribute name="action">
							<xsl:value-of select="$actionuri"/>
						</xsl:attribute>
						<input type="hidden" name="actionVal" value="{$actionval}"/>
						<xsl:call-template name="quickfilterfunctionality">
							<xsl:with-param name="title" select="$title"/>
							<xsl:with-param name="filtervalue" select="$filtervalue"/>
							<xsl:with-param name="onClickAction" select="$onClickAction"/>
							<xsl:with-param name="filterInputId" select="$filterInputId"/>
							<xsl:with-param name="filterInputName" select="$filterInputName"/>
						</xsl:call-template>
					</form>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="quickfilterfunctionality">
						<xsl:with-param name="title" select="$title"/>
						<xsl:with-param name="filtervalue" select="$filtervalue"/>
						<xsl:with-param name="onClickAction" select="$onClickAction"/>
						<xsl:with-param name="filterInputId" select="$filterInputId"/>
						<xsl:with-param name="filterInputName" select="$filterInputName"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>			
			
		</div>
	</xsl:template>
	
	
	
	<xsl:template name="quickfilterfunctionality">
		<xsl:param name="title"/>
		<xsl:param name="filtervalue" select="'filtervalue'"/>	
		<xsl:param name="onClickAction" select="'MM_filter()'"/>
		<xsl:param name="filterInputId"/>
		<xsl:param name="filterInputName" select="'filtervalue'"/>
		
		<!-- default action on "Go" button -->
		<xsl:call-template name="filterHiddenInputs"/>
		<!--  propagate the menu_file parameter -->
		<xsl:call-template name="menuFileHiddenInput" />
					
		<input type="hidden" name="filteraction" value=""/>
		<div class="input-group filter">
			<input type="text" class="filter_textinput form-control">
				<xsl:if test="$filterInputId != ''">
					<xsl:attribute name="id"><xsl:value-of select="$filterInputId"/></xsl:attribute>
				</xsl:if>
				<xsl:attribute name="name"><xsl:value-of select="$filterInputName"/></xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="$filtervalue"/></xsl:attribute>
				<xsl:attribute name="placeholder"><xsl:value-of select="$title"/></xsl:attribute>
			</input>
			<span class="input-group-btn">	
				<button type="submit" name="Go"  class="btn btn-default">
					<xsl:attribute name="onclick"><xsl:value-of select="$onClickAction"/></xsl:attribute>
					<i class="icon icon-normal icon-WCR_Actions-Search12"></i>
				</button>					
			</span>	
		</div>
	
	</xsl:template>
	
	
	
	<xsl:template name="clippedmessage">
		<xsl:param name="clipped"/>
		<xsl:param name="fullCnt"/>
		<xsl:param name="clippedCnt"/>
		<xsl:param name="showAllCheckBox" select="false ()"/>
		<xsl:param name="showAllAction" select="''"/>
		<xsl:if test="$clipped&gt;0">
			<div class="alert alert-warning">
				<xsl:value-of select="Lang:getStr(&lk;,'ITEM_LIST_CLIPPED')"/>&nbsp;<xsl:value-of select="Lang:getStr(&lk;,'FROM')"/>&nbsp;<xsl:value-of select="$fullCnt"/>&nbsp;<xsl:value-of select="Lang:getStr(&lk;,'TO')"/>&nbsp;<xsl:value-of select="$clippedCnt"/>.
				<xsl:if test="$showAllCheckBox">
					<a class="text-warning actionlink">
						<xsl:attribute name="href"><xsl:value-of select="$showAllAction"/></xsl:attribute>
						<xsl:value-of select="Lang:getStr(&lk;,'SHOW_ALL')"/>
					</a>
				</xsl:if>				
			</div>
		</xsl:if>
	</xsl:template>



	<!-- 
  
            template that replaces " with &quot; 
            
  -->
	<xsl:template name="encodedoublequotes">
		<xsl:param name="string"/>
		<xsl:choose>
			<xsl:when test="contains($string,'&quot;')">
				<xsl:value-of select="substring-before($string,'&quot;')"/>&amp;quot;<xsl:call-template name="encodedoublequotes">
					<xsl:with-param name="string" select="substring-after($string,'&quot;')"/></xsl:call-template></xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$string"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>



	<!-- 
		Template  for writing values in Javascript strings.
	  
	  @param string
	             the string to put inside the javascript string
	  @return the encoded string to put inside the javascript string
	-->
	<xsl:template name="encodesinglequotes">
		<xsl:param name="string"/>
		<xsl:value-of select="XSLUtils:encodeForJScriptExceptNewlines($string)"/>
	</xsl:template>

	<!-- 
		Template  for writing values in Javascript strings.
	  
	  @param string
	             the string to put inside the javascript string
	  @return the encoded string to put inside the javascript string
	-->
	<xsl:template name="escapequotationmark">
		<xsl:param name="string"/>
		<xsl:value-of select="XSLUtils:encodeForJScriptExceptNewlines($string)"/>
    </xsl:template>

	<!-- 
  
            template that replaces \ with \\
            
  -->
	<xsl:template name="encodebackslash">
		<xsl:param name="string"/>
		<xsl:choose>
			<xsl:when test='contains($string,"\")'>
				<xsl:value-of select='substring-before($string,"\")'/>&#x5C;&#x5C;<xsl:call-template name="encodebackslash">
					<xsl:with-param name="string" select='substring-after($string,"\")'/></xsl:call-template></xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$string"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- 
  
            template that replaces & with &amp;
            
  -->
	<xsl:template name="encodeamp">
		<xsl:param name="string"/>
		<xsl:choose>
			<xsl:when test='contains($string,"&amp;")'>
				<xsl:value-of select='substring-before($string,"&amp;")'/>&amp;amp;<xsl:call-template name="encodeamp">
					<xsl:with-param name="string" select='substring-after($string,"&amp;")'/></xsl:call-template></xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$string"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	
	 <!-- 
  
            template that displays a notification message in the body
            (only if the NOTIFICATION element exists)
            
  -->
	<xsl:template name="DisplayNotification">
	<xsl:param name="notificationType" select="'success'" />
	
	<xsl:variable name="notificationClass">
		<xsl:choose>
			<xsl:when test="NOTIFICATION[@iserror]">danger</xsl:when>
			<xsl:when test="NOTIFICATION[@iswarning]">warning</xsl:when>
			<xsl:otherwise><xsl:value-of select="$notificationType"></xsl:value-of></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:if test="NOTIFICATION">
		<div class="alert alert-{$notificationClass}  alert-dismissible wcr-display-notification">
			<button type="button" class="close" data-dismiss="alert" aria-label="Close">
				<i class="icon-small icon-WCR_Close12"></i>
			</button>
			<xsl:for-each select="NOTIFICATION">
				<p>
					<xsl:value-of select="." />
				</p>
			</xsl:for-each>
		</div>
	</xsl:if>
	</xsl:template>
	<!-- 
  
            template that displays a the link to a newly created element
            
  -->
	<xsl:template name="DisplayLinkToNewItem">
		<xsl:param name="createsuccesstext" />
	
		<div class="alert alert-success alert-dismissible" role="alert">
			<button type="button" class="close" data-dismiss="alert" aria-label="Close">
				<i class="icon-small icon-WCR_Close12"></i>
			</button>
			<form name="newitemlinkform" method="post" action="{rel_url}">
				
				<input type="hidden">
					<xsl:attribute name="name">
						<xsl:value-of select="key_name" />
					</xsl:attribute>
					<xsl:attribute name="value">
						<xsl:call-template name="encodedoublequotes">
							<xsl:with-param name="string" select="key" />
						</xsl:call-template>
					</xsl:attribute>
				</input>
				<a href="#" onclick="javascript:document.newitemlinkform.submit();">
					<xsl:value-of select="$createsuccesstext" />&nbsp;
					<xsl:value-of select="name" />!
				</a>
			</form>
		</div>

	</xsl:template>

	<!-- 
    	template to display a user full name with optional link to his/her details
   		*** include the detailswin.js script 
  	-->
	<xsl:template name="DisplayUserName">
		<xsl:param name="userID" select="''"/>
		<xsl:param name="lastName"/>
		<xsl:param name="firstName"/>
		<xsl:param name="displayNameStr" select="''"/>
		<xsl:param name="displayIcon" select="0"/>
		<xsl:param name="loginName" select="''"/>
		<xsl:param name="userDeleted" select="0"/>
		<xsl:param name="roleGroupNameList" select="''"/>
		<xsl:param name="isActive" select="1"/>
		<xsl:param name="onClick" select="'ShowUserDetails'" />

		<xsl:if test="string-length($displayNameStr) + string-length($loginName) + string-length($lastName) + string-length($firstName) &gt; 0">
			<!--  display the 'user' member type icon -->
			<xsl:if test="$displayIcon = '1'">
				<xsl:choose>
					<xsl:when test="$isActive = 0">
						<i class="icon icon-normal icon-warning icon-WCR_Actions-User-Deactivate12"></i>&nbsp;
					</xsl:when>
					<xsl:otherwise>
						<i class="icon icon-normal icon-grey icon-WCR_Assignee-User"></i>&nbsp;
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
			
			<xsl:variable name="classes">
				<xsl:choose>
					<xsl:when test="$isActive = 0">
						<xsl:value-of select="'text-warning'" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="''" />
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			
			<xsl:choose>
				<xsl:when test="$userDeleted = 1">
					<a class="{$classes}" href="#">
						<xsl:attribute name="onclick">javascript:alert('<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="Lang:getStr(&lk;,'USER_DELETED_INFO')"/></xsl:call-template>');</xsl:attribute>
						<xsl:call-template name="_DisplayUserNameString">
							<xsl:with-param name="displayNameStr" select="$displayNameStr"/>
							<xsl:with-param name="lastName" select="$lastName"/>
							<xsl:with-param name="firstName" select="$firstName"/>
							<xsl:with-param name="loginName" select="$loginName"/>
						</xsl:call-template>		
					</a>
				</xsl:when>
				<xsl:when test="string-length($userID) = 0">
					<!-- when userID parameter is empty, display the user name as simple text - no hyperlink -->
					<span class="{$classes}">
						<xsl:call-template name="_DisplayUserNameString">
							<xsl:with-param name="displayNameStr" select="$displayNameStr"/>
							<xsl:with-param name="lastName" select="$lastName"/>
							<xsl:with-param name="firstName" select="$firstName"/>
							<xsl:with-param name="loginName" select="$loginName"/>
						</xsl:call-template>	
					</span>	
				</xsl:when>			
				<xsl:otherwise>
					<a class="{$classes}" href="#" onclick="javascript:{$onClick}('{$userID}');">
						<xsl:call-template name="_DisplayUserNameString">
							<xsl:with-param name="displayNameStr" select="$displayNameStr"/>
							<xsl:with-param name="lastName" select="$lastName"/>
							<xsl:with-param name="firstName" select="$firstName"/>
							<xsl:with-param name="loginName" select="$loginName"/>
						</xsl:call-template>					
					</a>
				</xsl:otherwise>
			</xsl:choose>
			
			<xsl:if test="$isActive = 0">
				&nbsp;<span class="label label-warning"><xsl:value-of select="Lang:getStr(&lk;,'DEACTIVATED')"/></span>
			</xsl:if>
	
			<!-- user Role (if he/she is linked to any) -->
			<xsl:if test="string-length($roleGroupNameList) &gt; 0">
				&nbsp;<xsl:value-of select="Lang:getStr(&lk;,'AS_ROLE')"/>&nbsp;<xsl:value-of select="$roleGroupNameList"/>
			</xsl:if>
		</xsl:if>		
	</xsl:template>
	
	<!-- 
    	template to display a user full name with the details in a popover (on hover)
   		*** include the detailswin.js script 
  	-->
	<xsl:template name="DisplayUserNameWithPopover">
		<xsl:param name="userID" select="''"/>
		<xsl:param name="lastName" select="''"/>
		<xsl:param name="firstName" select="''"/>
		<xsl:param name="loginName" select="''"/>
		<xsl:param name="delegatorLastName" select="''"/>
		<xsl:param name="delegatorFirstName" select="''"/>
		<xsl:param name="delegatorLoginName" select="''"/>
		
		
		<div data-init="component/objectdetailspopover/ObjectDetailsPopoverFactory" data-type="user" data-user-id="{$userID}" data-delegator-user-name="{$delegatorLoginName}" data-delegator-first-name="{$delegatorFirstName}" data-delegator-last-name="{$delegatorLastName}" >
			<span class="object-popover-trigger">
				<xsl:call-template name="_DisplayUserNameString">
					<xsl:with-param name="lastName" select="$lastName"/>
					<xsl:with-param name="firstName" select="$firstName"/>
					<xsl:with-param name="loginName" select="$loginName"/>
				</xsl:call-template>	
			</span>	
		</div>
	</xsl:template>
	
	
	<!-- 
		Use template DisplayUserName! Displays the user name string for DisplayUserName.
		This is in most cases Last Name, First Name (User Name).
	-->
	<xsl:template name="_DisplayUserNameString">
		<xsl:param name="displayNameStr" select="''"/>
		<xsl:param name="lastName" />
		<xsl:param name="firstName"/>
		<xsl:param name="loginName" select="''"/>
		
		<xsl:choose>	
			<xsl:when test="string-length($displayNameStr) &gt; 0"><xsl:value-of select="$displayNameStr"/></xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="string-length($firstName) + string-length($lastName) &gt; 0">
						<!-- First and/or Last name is defined, so show them all -->
						<xsl:value-of select="$lastName"/>
						<xsl:if test="string-length($firstName) &gt; 0">,&nbsp;<xsl:value-of select="$firstName"/></xsl:if>
						<xsl:if test="string-length($loginName) &gt; 0">&nbsp;<xsl:value-of select="'('"/><xsl:value-of select="$loginName"/><xsl:value-of select="')'"/></xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<!-- No First and/or Last name, so only show username -->
						<xsl:if test="string-length($loginName) &gt; 0"><xsl:value-of select="$loginName"/></xsl:if>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>	
	</xsl:template>
	
	<!-- 
		Displays the user name string (text only)
		This is in most cases Last Name, First Name (User Name) [deactivated].
		This is the standard format for dropdowns.
	-->
	<xsl:template name="DisplayUserNameTextOnly">
		<xsl:param name="displayNameStr" select="''"/>
		<xsl:param name="lastName" />
		<xsl:param name="firstName"/>
		<xsl:param name="loginName" select="''"/>
		<xsl:param name="isActive" select="1"/>
		<xsl:param name="roleGroupNameList" select="''"/>
		
		<xsl:call-template name="_DisplayUserNameString">
			<xsl:with-param name="displayNameStr" select="$displayNameStr"/>
			<xsl:with-param name="lastName" select="$lastName"/>
			<xsl:with-param name="firstName" select="$firstName"/>
			<xsl:with-param name="loginName" select="$loginName"/>
		</xsl:call-template>
		<xsl:if test="$isActive = 0">&nbsp;[<xsl:value-of select="Lang:getStr(&lk;,'DEACTIVATED')"/>]</xsl:if>
		<!-- user Role (if he/she is linked to any) -->
		<xsl:if test="string-length($roleGroupNameList) &gt; 0">
			&nbsp;<xsl:value-of select="Lang:getStr(&lk;,'AS_ROLE')"/>&nbsp;<xsl:value-of select="$roleGroupNameList"/>
		</xsl:if>
	</xsl:template>
	
  <!-- 
    template to display a link to a Project details
    *** include the detailswin.js script 
  -->
	<xsl:template name="DisplayProjectName">
		<xsl:param name="projectID"/>
		<xsl:param name="projectName"/>

		<xsl:choose>
			<xsl:when test="(string-length($projectID) &gt; 0) and (string-length($projectName) &gt; 0)">
				<a href="showprojectdetails.jsp?projectID={$projectID}" onclick="javascript:ShowProjectDetails('{$projectID}');event.preventDefault();" target="_blank">
					<xsl:value-of select="$projectName"/>				
				</a>
			</xsl:when>
			<xsl:otherwise>&nbsp;</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- 
    	template to display a link to a group name details + potential assigned role feeback
   		*** include the detailswin.js script 
  	-->
	<xsl:template name="DisplayGroupName">
		<xsl:param name="groupID" select="''"/>
		<xsl:param name="projectID" select="''"/>
		<xsl:param name="groupName"/>
		<xsl:param name="roleGroupNameList" select="''"/>
		<xsl:param name="isEmpty" select="0"/>
		<xsl:param name="isRole" select="-1"/>
		<xsl:param name="displayIcon" select="0"/>
		<xsl:param name="onClick" select="'ShowGroupDetails'"/>
		
		<xsl:if test="string-length($groupName) &gt; 0">
			<!--  display the 'group' member type icon -->
			<xsl:if test="$displayIcon = '1'">
				<xsl:choose>
					<!-- distinguish between a regular group and a role (which is also 'a group' behind the scenes/in the DB) -->
					<xsl:when test="not($isRole = 1)">
						<i class="icon icon-normal icon-green icon-WCR_Assignee-Group"></i>
					</xsl:when>
					<xsl:otherwise>
						<i class="icon icon-normal icon-blue icon-WCR_Assignee-Role"></i>
					</xsl:otherwise>
				</xsl:choose>
				&nbsp;
			</xsl:if>
			
			<!-- Group Name with (or without) a link to group details -->
			<xsl:choose>
				<xsl:when  test="string-length($groupID) = 0">
					<xsl:value-of select="$groupName"/> 
				
					<!-- check if we need to write Group/Role type tag -->
					<xsl:if test="$displayIcon = '0'">
						<xsl:choose>
							<xsl:when test="$isRole = -1"><!-- do nothing --></xsl:when>
							<xsl:when test="($isRole = 1)">&nbsp;&lt;<xsl:value-of select="Lang:getStr(&lk;,'ABBREV_ROLE')"/>&gt;</xsl:when>
							<xsl:otherwise>&nbsp;&lt;<xsl:value-of select="Lang:getStr(&lk;,'ABBREV_GROUP')"/>&gt;</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</xsl:when>
				
				<xsl:otherwise>
					<!-- write out an HTML Link that opens Role/Group details popup -->
					<a href="#" onclick="javascript:{$onClick}('{$groupID}', '{$projectID}', '{$isRole}');">
						<xsl:value-of select="$groupName"/>
						
						<!-- check if we need to write Group/Role type tag -->
						<xsl:if test="$displayIcon = '0'">
							<xsl:choose>
								<xsl:when test="$isRole = -1"><!-- do nothing --></xsl:when>
								<xsl:when test="$isRole = 1">&nbsp;&lt;<xsl:value-of select="Lang:getStr(&lk;,'ABBREV_ROLE')"/>&gt;</xsl:when>
								<xsl:otherwise>&nbsp;&lt;<xsl:value-of select="Lang:getStr(&lk;,'ABBREV_GROUP')"/>&gt;</xsl:otherwise>
							</xsl:choose>
						</xsl:if>
					</a>
				</xsl:otherwise>
			</xsl:choose>				
	
			<!-- Role Group (if it is linked to the processed Group) -->
			<xsl:if test="string-length($roleGroupNameList) &gt; 0">
				&nbsp;<xsl:value-of select="Lang:getStr(&lk;,'AS_ROLE')"/>&nbsp;<xsl:value-of select="$roleGroupNameList"/>
			</xsl:if>
			
			<!-- display EMPTY flag if it is the case -->
			<xsl:if test="($isEmpty = '1') and ($isRole != 1)">
				&nbsp;&nbsp;<xsl:value-of select="'('"/><xsl:value-of select="Lang:getStr(&lk;,'EMPTY_ELEMENT')"/><xsl:value-of select="')'"/>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	
	<!--  
	
		Used to write out Project Role name along with all its active Group/User Assignments
		Makes use of an explicit XML structure: the parent JSP is required to have this XML structure available via a call to: ProjDetailsUtils.getProjectRoleAssignmentViewXML
	-->
	<xsl:template name="DisplayRoleNameWithAssignments">
		<xsl:param name="projectID" select="''"/>
		<xsl:param name="roleAssignmentData"/>
		
		<!-- wrap the contents in a TABLE element, as it could require multiple lines in the output -->
		<table class="darktext_darklink_11">
			<!-- first display the Project Role information -->
			<tr>
				<td>
					<xsl:call-template name="DisplayGroupName">
						<xsl:with-param name="groupID" select="$roleAssignmentData/role_group/@id"/>
						<xsl:with-param name="projectID" select="$projectID"/>
						<xsl:with-param name="groupName" select="$roleAssignmentData/role_group"/>
						<xsl:with-param name="isRole" select="'1'"/>
						<xsl:with-param name="displayIcon" select="1"/>
					</xsl:call-template>
				</td>
			</tr>	
			
			<!-- display User Assignments data -->
			<xsl:for-each select="$roleAssignmentData/assigned_users_list/assigned_user">
				<tr>
					<td>
						<xsl:call-template name="DisplayUserName">
							<xsl:with-param name="userID" select="user/@id"/>
							<xsl:with-param name="lastName" select="user/last_name"/>
							<xsl:with-param name="firstName" select="user/first_name"/>
							<xsl:with-param name="loginName" select="user/name" />
							<xsl:with-param name="isActive" select="user/is_active" />
							<xsl:with-param name="displayIcon" select="1"/>
						</xsl:call-template>
					</td>
				</tr>
			</xsl:for-each>
			
			
			<!-- display Group Assignments data -->
			<xsl:for-each select="$roleAssignmentData/assigned_groups_list/assigned_group">
				<tr>
					<td>
						<xsl:if test="assigned_group_assignee">
							<xsl:call-template name="DisplayUserName">
								<xsl:with-param name="userID" select="assigned_group_assignee/user/@id"/>
								<xsl:with-param name="lastName" select="assigned_group_assignee/user/last_name"/>
								<xsl:with-param name="firstName" select="assigned_group_assignee/user/first_name"/>
								<xsl:with-param name="loginName" select="assigned_group_assignee/user/name" />
								<xsl:with-param name="isActive" select="assigned_group_assignee/user/is_active" />
								<xsl:with-param name="displayIcon" select="1"/>
							</xsl:call-template>
							&nbsp;@&nbsp;
						</xsl:if>
	
						<!-- ...display the Group Name -->
						<xsl:call-template name="DisplayGroupName">
							<xsl:with-param name="groupID" select="@id"/>
							<xsl:with-param name="groupName" select="assigned_group_name"/>
							<xsl:with-param name="displayIcon" select="1"/>
						</xsl:call-template>
					</td>
				</tr>
			</xsl:for-each>		
		</table>
		
	</xsl:template>
	
	<!--  
	
		Used to write out Project Role name along with all its active Group/User Assignments
		Makes use of an explicit XML structure: the following needs to be used to generate the structure > RoleAssignmentDataViewXml.getInXML
	-->
	<xsl:template name="DisplayRoleNameWithAssignmentsInTable">
		<xsl:param name="projectID" select="''"/>
		<xsl:param name="roleAssignmentData"/>
		
		<!-- wrap the contents in a TABLE element, as it could require multiple lines in the output -->
		<table>
			<!-- first display the Project Role information -->
			<tr>
				<td>
					<xsl:call-template name="DisplayGroupName">
						<xsl:with-param name="groupID" select="$roleAssignmentData/group/@id"/>
						<xsl:with-param name="projectID" select="$projectID"/>
						<xsl:with-param name="groupName" select="$roleAssignmentData/group/name"/>
						<xsl:with-param name="isRole" select="'1'"/>
						<xsl:with-param name="displayIcon" select="1"/>
					</xsl:call-template>
				</td>
			</tr>	
			
			<!-- display User Assignments data -->
			<xsl:for-each select="$roleAssignmentData/user_assignees/user_list/user">
				<tr>
					<td>
						<xsl:call-template name="DisplayUserName">
							<xsl:with-param name="userID" select="@id"/>
							<xsl:with-param name="lastName" select="last_name"/>
							<xsl:with-param name="firstName" select="first_name"/>
							<xsl:with-param name="loginName" select="name"/>
							<xsl:with-param name="displayIcon" select="1"/>
							<xsl:with-param name="isActive" select="is_active" />
						</xsl:call-template>
					</td>
				</tr>
			</xsl:for-each>
				
			<!-- display Group Assignments data -->
			<xsl:for-each select="$roleAssignmentData/group_assignees/group_assignee">
				<tr>
					<td>
						<xsl:if test="user">
							<xsl:call-template name="DisplayUserName">
								<xsl:with-param name="userID" select="user/@id"/>
							<xsl:with-param name="lastName" select="user/last_name"/>
							<xsl:with-param name="firstName" select="user/first_name"/>
							<xsl:with-param name="loginName" select="user/name"/>
							<xsl:with-param name="displayIcon" select="1"/>
							<xsl:with-param name="isActive" select="user/is_active" />
							</xsl:call-template>
							&nbsp;@&nbsp;
						</xsl:if>
	
						<!-- ...display the Group Name -->
						<xsl:call-template name="DisplayGroupName">
							<xsl:with-param name="groupID" select="group/@id"/>
							<xsl:with-param name="groupName" select="group/name"/>
							<xsl:with-param name="displayIcon" select="1"/>
						</xsl:call-template>
					</td>
				</tr>
			</xsl:for-each>		
		</table>
		
	</xsl:template>

	<!-- 
    template to display a linke to a location details
   *** include the detailswin.js script 
  -->
	<xsl:template name="DisplayCompanyLocation">
		<xsl:param name="locationID"/>
		<xsl:param name="companyName"/>
		<xsl:param name="locationName"/>
		<xsl:choose>
			<xsl:when test="string-length($locationID)&gt;0">
				<a href="#" onclick="javascript:ShowLocationDetails('{$locationID}');">
					<xsl:value-of select="$companyName"/>/<xsl:value-of select="$locationName"/></a>
			</xsl:when>
			<xsl:when test="string-length($companyName)&gt;0">
					<xsl:value-of select="$companyName"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="DisplayNoCompanyLocation" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="DisplayNoCompanyLocation">
		&nbsp;
	</xsl:template>

	<!--
            Template that formats floating point values with the "correct" number of decimal points.
-->
	<xsl:template name="formatFloat">
		<xsl:param name="value"/>

		<xsl:variable name="numericValue" select="number($value)"/>

		<xsl:if test="string($numericValue) != 'NaN'">
			<!-- Make sure we don't show a million decimal points -->
			<xsl:variable name="absValue" select="Math:abs($numericValue)"/>
			<xsl:variable name="fmt">
				<xsl:choose>
					<xsl:when test="$absValue &gt; 1">
						<xsl:choose>
							<xsl:when test="/webcenter_page/user_units != 'metric'">#.000</xsl:when>
							<xsl:otherwise>#.00</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$absValue &lt; .000001">#.##########</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="$absValue &lt; .00001">#.#########</xsl:when>
									<xsl:otherwise>
										<xsl:choose>
											<xsl:when test="$absValue &lt; .0001">#.########</xsl:when>
											<xsl:otherwise>
												<xsl:choose>
													<xsl:when test="$absValue &lt; .001">#.#######</xsl:when>
													<xsl:otherwise>
														<xsl:choose>
															<xsl:when test="$absValue &lt; .01">#.######</xsl:when>
															<xsl:otherwise>
																<xsl:choose>
																	<xsl:when test="$absValue &lt; .1">#.#####</xsl:when>
																	<xsl:otherwise>#.####</xsl:otherwise>
																</xsl:choose>
															</xsl:otherwise>
														</xsl:choose>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:value-of select="format-number($numericValue, $fmt)"/>
		</xsl:if>
	</xsl:template>

	<xsl:template name="menuFileHiddenInput">
		<xsl:if test="/webcenter_page/menu_file">
		<input type="hidden" name="menu_file" value="{/webcenter_page/menu_file}"/>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="sessionTokenHiddenInput">
		<xsl:if test="/webcenter_page/token_session">
		<input type="hidden" name="token_session" value="{/webcenter_page/token_session}"/>
		</xsl:if>
	</xsl:template>

	<xsl:template name="projectDetailsHref">
		<xsl:param name="page" select="'projdetails.jsp'"/>
		<xsl:param name="projectID" select="/webcenter_page/project/@id"/>
		<xsl:param name="folderID" select="/webcenter_page/folder/@id"/>
		
		<xsl:variable name="altPage">
			<xsl:choose>
				<xsl:when test="contains($page,'?')"><xsl:value-of select="normalize-space($page)"/>&amp;</xsl:when>
				<xsl:otherwise><xsl:value-of select="normalize-space($page)"/>?</xsl:otherwise>
				</xsl:choose>
		</xsl:variable>
		
		<xsl:attribute name="href">
			<xsl:value-of select="$altPage"/>projectID=<xsl:value-of select="$projectID"/>&amp;folderID=<xsl:value-of select="$folderID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/></xsl:attribute>
	</xsl:template>

	<!--  Links to the project docs page with the folder for this document selected -->
	<xsl:template name="projectDocsHref">
		<xsl:param name="projectID"/>
		<xsl:param name="docVerID"/>

		<xsl:attribute name="href">projdetailsdocs.jsp?projectID=<xsl:value-of select="$projectID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/>&amp;docVerID=<xsl:value-of select="$docVerID"/></xsl:attribute>
	</xsl:template>

	<!--  Build reference to the project. This link will redirect to the default project page. -->
	<xsl:template name="projectHref">
		<xsl:param name="projectID"/>
		<xsl:param name="docVerID"/>
		<xsl:attribute name="href">projdetails.jsp?projectID=<xsl:value-of select="$projectID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/>&amp;docverid=<xsl:value-of select="$docVerID"/></xsl:attribute>
	</xsl:template>

	<xsl:template name="docDetailsHref">
		<xsl:param name="page" select="'docdetails.jsp'"/>
		<xsl:param name="docVerID" select="/webcenter_page/doc_version/@id"/>
		<xsl:param name="docID" select="/webcenter_page/doc_version/document_id"/>	
		<xsl:param name="showInNewWindow" select="false()"/>
		<xsl:param name="projectId"/>

		<xsl:choose>
			<xsl:when test="$showInNewWindow = true()">
				<xsl:attribute name="href">#</xsl:attribute>
				<xsl:attribute name="onclick">javascript:ShowFullDocumentDetails('<xsl:value-of select="$docVerID"/>', '<xsl:value-of select="/webcenter_page/menu_file"/>');</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="href">
					<xsl:choose>
						<xsl:when test="contains($page,'?')"> 
							<xsl:value-of select="normalize-space($page)"/>&amp;docVerID=<xsl:value-of select="$docVerID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/>&amp;docID=<xsl:value-of select="$docID"/><xsl:if test="$projectId">&amp;projectID=<xsl:value-of select="$projectId"/></xsl:if>
						</xsl:when>
						<xsl:otherwise>
			 					<xsl:value-of select="normalize-space($page)"/>?docVerID=<xsl:value-of select="$docVerID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/>&amp;docID=<xsl:value-of select="$docID"/><xsl:if test="$projectId">&amp;projectID=<xsl:value-of select="$projectId"/></xsl:if>
						</xsl:otherwise>								
					</xsl:choose>
				</xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Links to a specific task inside of the project tasks -->
	<xsl:template name="taskDetailsHref">
		<xsl:param name="page" select="'projdetailswctaskdetailsgeninfo.jsp'"/>
		<xsl:param name="projectID" select="/webcenter_page/project/@id"/>
		<xsl:param name="wctaskID" select="/webcenter_page/project_wctask/@id"/>
		<xsl:param name="sourcePage" select="'projdetailswctasks.jsp'"/>
		<xsl:attribute name="href">
			<xsl:value-of select="normalize-space($page)"/>?projectID=<xsl:value-of select="$projectID"/>&amp;curProjTaskID=<xsl:value-of select="$wctaskID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/>&amp;sourcePage=<xsl:value-of select="XSLUtils:urlEncode($sourcePage)"/></xsl:attribute>
	</xsl:template>

	<xsl:template name="docViewHref">
		<xsl:param name="page" select="'viewdocument.jsp'"/>
		<xsl:param name="pageAnnotations" select="'docdetailsannotations.jsp'"/>
		<xsl:param name="docVerID" select="/webcenter_page/doc_version/@id"/>
		<xsl:param name="pageIndex" select="0"/>
		<xsl:param name="sourcePage" select="''"/>
		<xsl:param name="openOnAnnotation" select="false()"/>		
		<xsl:attribute name="href">
			<xsl:choose>
				<xsl:when test="$openOnAnnotation='true'"><xsl:value-of select="$pageAnnotations"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="$page"/></xsl:otherwise>
			</xsl:choose>?docVerID=<xsl:value-of select="$docVerID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/>&amp;pageIndex=<xsl:value-of select="$pageIndex"/><xsl:if test="$sourcePage!=''">&amp;sourcePage=<xsl:value-of select="$sourcePage"/></xsl:if>
		</xsl:attribute>
	</xsl:template>

	<xsl:template name="docViewUrl">
		<xsl:param name="page" select="'viewdocument.jsp'"/>
		<xsl:param name="pageAnnotations" select="'docdetailsannotations.jsp'"/>
		<xsl:param name="docVerID" select="/webcenter_page/doc_version/@id"/>
		<xsl:param name="pageIndex" select="0"/>
		<xsl:param name="sourcePage" select="''"/>
		<xsl:param name="openOnAnnotation" select="false()"/>		
		<xsl:choose>
			<xsl:when test="$openOnAnnotation='true'"><xsl:value-of select="$pageAnnotations"/></xsl:when>
			<xsl:otherwise><xsl:value-of select="$page"/></xsl:otherwise>
		</xsl:choose>?docVerID=<xsl:value-of select="$docVerID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/>&amp;pageIndex=<xsl:value-of select="$pageIndex"/><xsl:if test="$sourcePage!=''">&amp;sourcePage=<xsl:value-of select="$sourcePage"/></xsl:if>
	</xsl:template>

	<xsl:template name="docView3DHref">
		<xsl:param name="page" select="'viewdocument.jsp'"/>
		<xsl:param name="docVerID" select="/webcenter_page/doc_version/@id"/>
		<xsl:param name="sourcePage" select="''"/>
		<xsl:attribute name="href">
			<xsl:value-of select="$page"/>?docVerID=<xsl:value-of select="$docVerID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/><xsl:if test="$sourcePage!=''">&amp;sourcePage=<xsl:value-of select="$sourcePage"/></xsl:if>
		</xsl:attribute>
	</xsl:template>

	<xsl:template name="docView3DUrl">
		<xsl:param name="page" select="'viewdocument.jsp'"/>
		<xsl:param name="docVerID" select="/webcenter_page/doc_version/@id"/>
		<xsl:param name="sourcePage" select="''"/>
		<xsl:value-of select="$page"/>?docVerID=<xsl:value-of select="$docVerID"/>&amp;show3D=1&amp;<xsl:call-template name="menuFileUrlParameter"/><xsl:if test="$sourcePage!=''">&amp;sourcePage=<xsl:value-of select="$sourcePage"/></xsl:if>
	</xsl:template>

	<xsl:template name="ProjectNameLink">
		<xsl:param name="projectID" />
		<xsl:param name="projectName" />
		<xsl:param name="showSimpleGUI" select="'0'"/>
	
		<xsl:choose>
			<!-- Simple HP GUI > only show a details window for the Project -->
			<xsl:when test="$showSimpleGUI = '1'">
				<xsl:call-template name="DisplayProjectName">
					<xsl:with-param name="projectID" select="$projectID"/>
					<xsl:with-param name="projectName" select="$projectName"/>
				</xsl:call-template>						
			</xsl:when>
			<!-- Write out a standard WCR navigational link to the Project -->
			<xsl:otherwise>
				<a>
				  <xsl:call-template name="projectDetailsHref">
					<xsl:with-param name="projectID" select="$projectID"/>
					</xsl:call-template>
				  <xsl:value-of select="$projectName"/>
				</a>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- redirect to the history page -->
	<xsl:template name="docViewVersionHistory">
		<xsl:param name="page" select="'docdetailsactionversionhistory.jsp'"/>
		<xsl:param name="docVerID" select="/webcenter_page/doc_version/@id"/>
		<xsl:attribute name="href">
			<xsl:value-of select="$page"/>?docVerID=<xsl:value-of select="$docVerID"/>&amp;<xsl:call-template name="menuFileUrlParameter"/></xsl:attribute>
	</xsl:template>



	<xsl:template name="menuFileUrlParameter">menu_file=<xsl:value-of select="/webcenter_page/menu_file"/></xsl:template>

	<!-- 
			template that creates an empty table row with Cols columns;
	-->
	<xsl:template name="EmptyRow">
		<xsl:param name="Cols" select="1"/>
		<tr>
			<td class="firstCol"/>
			<td><xsl:attribute name="colspan"><xsl:value-of select="$Cols"/></xsl:attribute>&nbsp;</td>
			<td class="lastCol"/>
		</tr>			
	</xsl:template>
	
	<xsl:template name="EmptyTableSection">
		<xsl:param name="message" select="''"/>
		<div class="no-results">
			<xsl:choose>
				<xsl:when test="$message = ''">
					<xsl:value-of select="Lang:getStr(&lk;,'ERRNOITEMSFOUND')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$message"/>
				</xsl:otherwise>
			</xsl:choose>			
		</div>	
	</xsl:template>
	
	
	<!-- 
            template that encodes \n with <br>
  -->
	<xsl:template name="replacereturnwithbreak">
		<xsl:param name="string"/>
		<xsl:choose>
			<xsl:when test="contains($string,'&#xA;')">
				<xsl:value-of select="substring-before($string,'&#xA;')"/>&lt;br/&gt;<xsl:call-template name="replacereturnwithbreak">
					<xsl:with-param name="string" select="substring-after($string,'&#xA;')"/></xsl:call-template></xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$string"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
  <!-- 
            template that interprets <br>
  -->
	<xsl:template name="replace-br">
		<xsl:param name="string"/>
		<xsl:choose>
			<xsl:when test="contains($string,'&lt;br/&gt;')">
				<xsl:value-of select="substring-before($string,'&lt;br/&gt;')"/>
				<br/>
				<xsl:call-template name="replace-br">
					<xsl:with-param name="string" select="substring-after($string,'&lt;br/&gt;')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$string"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
  
  
  <!-- 
		Template to replace given substring 'replace' with substring 'with' in string 'text'.
	-->
	<xsl:template name="replace-string">
	  <xsl:param name="text"/>
	  <xsl:param name="replace"/>
	  <xsl:param name="with"/>
	  <xsl:choose>
	    <xsl:when test="contains($text,$replace)">
	      <xsl:value-of select="substring-before($text,$replace)"/>
	      <xsl:value-of select="$with"/>
	      <xsl:call-template name="replace-string">
	        <xsl:with-param name="text" select="substring-after($text,$replace)"/>
	        <xsl:with-param name="replace" select="$replace"/>
	        <xsl:with-param name="with" select="$with"/>
	      </xsl:call-template>
	    </xsl:when>
	    <xsl:otherwise>
	      <xsl:value-of select="$text"/>
	    </xsl:otherwise>
	  </xsl:choose>
	</xsl:template>



	<!--
	template that displays description by a given width 
-->
	<xsl:template name="CutDescription">
		<xsl:param name="Description"/>
		<xsl:param name="Width"/>
		<xsl:param name="Tolerance" select="6"/>
		<xsl:variable name="EncodedQuotesDescription">
			<xsl:call-template name="encodesinglequotes">
				<xsl:with-param name="string" select="$Description"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="EncodedDescription">
			<xsl:call-template name="replacereturnwithbreak">
				<xsl:with-param name="string" select="$EncodedQuotesDescription"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="not(/webcenter_page/media_print = '1') and (string-length($Description) &gt; (number($Width) + number ($Tolerance))) ">
				<xsl:value-of select="substring($Description, 1, $Width)"/>&nbsp;
				<span>
					<a onMouseout="delayhidepopup()">
						<xsl:attribute name="onMouseover">showmenu(event,'<xsl:value-of select="$EncodedDescription"/>');</xsl:attribute>(...)</a>
				</span>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$Description"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
	
	Template that controls display of a name within or without a thumbnail.
	
-->
	<xsl:template name="DisplayThumbnailName">
		<xsl:param name="showThumbnails"/>
		<xsl:param name="hrefValue"/>
		<xsl:param name="thumbhrefValue"/>
		<xsl:param name="urlKey"/>
		<xsl:param name="urlKeyName"/>
		<xsl:param name="defColspan" select="'1'"/>
		<xsl:param name="showThumbnailPopup" select="0"/>
		<xsl:param name="docFileSize" select="0"/>
		<xsl:param name="docVerID" select="''"/>
		<xsl:param name="projectID" select="''"/>
		<xsl:param name="projectName" select="''"/>
		<xsl:param name="documentName" select="''"/>
		<xsl:param name="ArtiosCADOpenType" select="'None'"/>
		<xsl:param name="checkoutOwnerUserID" select="''"/>
		<xsl:param name="docTypeID" select="''"/>
		<!-- Possible values of "noHyperLinks":
			0 => create Hyperlinks that open the link in the current tab
			1 => don't create Hyperlinks 
			2 => create Hyperlinks that open the link in a new tab
		 -->
		<xsl:param name="noHyperlinks" select="0"/>
		
		<!-- optional: generate the thumbnail td yourself -->
		<xsl:param name="useThumbnailCellHtml"/>
		<xsl:param name="thumbnailCellHtml"/>
		<xsl:param name="useDrilldown" select="0"/>
		<xsl:param name="drilldownCell"/>
		
		<xsl:choose>
			<!-- Show thumbnails mode -->
			<xsl:when test="$showThumbnails = 1">
				<td class="display-name thumbnail-and-name" colspan="{$defColspan}">
					<table width="100%" border="0" cellspacing="0" cellpadding="0">
						<tr>
							<xsl:if test="$useDrilldown = '1'">
								<td class="td-narrow td-center">
									<xsl:copy-of select="$drilldownCell"/>
								</td>
							</xsl:if>
							<xsl:choose>
								<xsl:when test="$useThumbnailCellHtml='1'">
									<xsl:copy-of select="$thumbnailCellHtml"/>
								</xsl:when>
								<xsl:otherwise>
									<td valign="middle" width="56">
										<xsl:variable name="encdocname">
											<xsl:value-of select="XSLUtils:encodeForJScript($urlKeyName/name)"/>
										</xsl:variable>		
										<xsl:choose>
											<xsl:when test="$noHyperlinks = 1">
												<xsl:choose>
													<xsl:when test="$showThumbnailPopup = 0">
														<img border="0" alt="" width="50" height="50" align="middle">
															<xsl:attribute name="src">
																<xsl:value-of select="$urlKey"/>
															</xsl:attribute>
														</img>
													</xsl:when>
													<xsl:otherwise>
														<img onMouseout="delayhidethumb()" onMouseover="showthumb(event,'{$urlKey}','{$encdocname}','202', null, 'DownloadViewerThumbnail.jsp?docversionid={$docVerID}&amp;pix=500&amp;ajax=1', 500);" src="{$urlKey}" alt="{$urlKey}" width="50" height="50" border="0" align="middle"/>							
													</xsl:otherwise>
												</xsl:choose>
											</xsl:when>
											<xsl:otherwise>
												<a>
													<xsl:attribute name="href">
														<xsl:value-of select="$thumbhrefValue"/>
													</xsl:attribute>
													<xsl:choose>
														<xsl:when test="$showThumbnailPopup = 0">
															<img border="0" alt="" width="50" height="50" align="middle">
																<xsl:attribute name="src">
																	<xsl:value-of select="$urlKey"/>
																</xsl:attribute>
															</img>
														</xsl:when>
														<!-- Show thumbnail popup -->
														<xsl:otherwise>
															<!-- when the thumbnail is not the default thumbnail, show the hoover -->
															<xsl:choose>
																<xsl:when test="not(starts-with($urlKey, 'thumbnails'))">
																	<xsl:choose>
																		<xsl:when test="string-length($docVerID) = 0">
																			<img onMouseout="delayhidethumb()" onMouseover="showthumb(event,'{$urlKey}','{$encdocname}','202'); " alt="" width="50" height="50" border="0" align="middle" src="{$urlKey}"/>
																		</xsl:when>
																		<xsl:otherwise>
														    				<img onMouseout="delayhidethumb()" onMouseover="showthumb(event,'{$urlKey}','{$encdocname}','202', null, 'DownloadViewerThumbnail.jsp?docversionid={$docVerID}&amp;pix=500&amp;ajax=1', 500);" src="{$urlKey}" alt="{$urlKey}" width="50" height="50" border="0" align="middle"/>
																		</xsl:otherwise>
																	</xsl:choose>
																</xsl:when>
																<xsl:otherwise>
																	<img alt="" width="50" height="50" border="0" align="middle" src="{$urlKey}"/>
																</xsl:otherwise>
															</xsl:choose>
														</xsl:otherwise>
													</xsl:choose>
												</a>							
											</xsl:otherwise>
										</xsl:choose>
										
									</td>
								</xsl:otherwise>
							</xsl:choose>
							<td valign="middle" class="add-padding-left">

								<xsl:choose>
									<xsl:when test="$noHyperlinks = 1">
										<p>
											<xsl:value-of select="$urlKeyName/name"/>
										</p>							
									</xsl:when>
									<xsl:otherwise>
										<a>
											<xsl:if test="$noHyperlinks = 2">
												<xsl:attribute name="target">_blank</xsl:attribute>
											</xsl:if>
											<xsl:attribute name="href">
												<xsl:value-of select="$hrefValue"/>
											</xsl:attribute>
											<xsl:value-of select="$urlKeyName/name"/>
										</a>
										
									
										<xsl:if test="$docFileSize != 0">
											<span class="darktext_darklink_10" nowrap="nowrap">
												&nbsp;
												<xsl:value-of select="'('"/>
												<xsl:call-template name="FormatFileSize">
													<xsl:with-param name="filesize" select="$docFileSize"/>
												</xsl:call-template>
												<xsl:value-of select="')'"/>
											</span>
										</xsl:if>
										<!-- Show 'Locked' icon if we received a valid "Checkout Owner User ID" reference -->
										<xsl:if test="string-length($checkoutOwnerUserID) &gt; 0">
											<span class="ml10" align="left">
												<i class="icon icon-normal icon-WCR_Actions-Lock12" title="{Lang:getStr(&lk;,'DOC_CHECKED_OUT')}"></i>
											</span>
										</xsl:if>
										
		
										<span style="float: right;">
											<!-- 
												NOTE: if ArtiosCADOpenType has a real value ('Standard'/'Enterpirse') 
					     						the parent/calling XSL template HAS to make sure function OpenInACAD(openMode, docVersionID, projectName, documentName) JS function is implemented 
					     					-->
											<xsl:if test="not($ArtiosCADOpenType = 'None')">
				  								<xsl:variable name="openInACADJSString">javascript:OpenInACAD('<xsl:value-of select="$ArtiosCADOpenType"/>', '<xsl:value-of select="$docVerID"/>', '<xsl:value-of select="XSLUtils:encodeForJScript($projectName)"/>', '<xsl:value-of select="XSLUtils:encodeForJScript($documentName)"/>');</xsl:variable>
				  								<a href="#" onclick="{$openInACADJSString}" style="padding: 0px 5px">					
													<img src="images/open_acad.png" alt="{Lang:getStr(&lk;,'DOCOPENINACAD')}" title="{Lang:getStr(&lk;,'DOCOPENINACAD')}"/>
												</a>
			  								</xsl:if>
										</span>							
									</xsl:otherwise>
								</xsl:choose>
							</td>
						</tr>
					</table>
				</td>
			</xsl:when>
			<!-- Hide thumbnails mode -->
			<xsl:otherwise>

				<td class="display-name name-only" colspan="{$defColspan}">
					<div class="display-name_name-only_container">
						<xsl:if test="$useDrilldown = '1'">
						<xsl:copy-of select="$drilldownCell"/>
						</xsl:if>
						<xsl:choose>
							<xsl:when test="$noHyperlinks = 1">
								<p>
									<xsl:value-of select="$urlKeyName/name"/>
								</p>							
							</xsl:when>
							<xsl:otherwise>
								<a>
									<xsl:if test="$noHyperlinks = 2">
										<xsl:attribute name="target">_blank</xsl:attribute>
									</xsl:if>
									<xsl:attribute name="href">
										<xsl:value-of select="$hrefValue"/>
									</xsl:attribute>
									<xsl:value-of select="$urlKeyName/name"/>
								</a>
								<!-- Show 'Locked' icon if we received a valid "Checkout Owner User ID" reference -->
								<xsl:if test="string-length($checkoutOwnerUserID) &gt; 0">
									<span class="ml10" align="left">
										<i class="icon icon-normal icon-WCR_Actions-Lock12" title="{Lang:getStr(&lk;,'DOC_CHECKED_OUT')}"></i>
									</span>
								</xsl:if>
											
								<!-- 
									NOTE: if ArtiosCADOpenType has a real value ('Standard'/'Enterpirse') 
			     					the parent/calling XSL template HAS to make sure function OpenInACAD(openMode, docVersionID, projectName, documentName) JS function is implemented 
			     				-->
								<xsl:if test="not($ArtiosCADOpenType = 'None')">
									<span style="float: right;">
										<xsl:variable name="openInACADJSString">javascript:OpenInACAD('<xsl:value-of select="$ArtiosCADOpenType"/>', '<xsl:value-of select="$docVerID"/>', '<xsl:value-of select="XSLUtils:encodeForJScript($projectName)"/>', '<xsl:value-of select="XSLUtils:encodeForJScript($documentName)"/>');</xsl:variable>
			 								<a href="#" onclick="{$openInACADJSString}" style="padding: 0px 5px">					
											<img src="images/open_acad.png" alt="{Lang:getStr(&lk;,'DOCOPENINACAD')}" title="{Lang:getStr(&lk;,'DOCOPENINACAD')}"/>
										</a>
									</span>
								</xsl:if>
							</xsl:otherwise>		
						</xsl:choose>
					</div>
				</td>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
		
<!--	
	Template, that returns string from dictionary for langkey, or alternative string, if the translation(OR the langkey itself) doesn't exist
-->
	<xsl:template name="GetLocalizedLabelOrAlternative">
		<xsl:param name="langKey"/>
		<xsl:param name="alternativeLabel"/>
		<xsl:value-of select="Lang:getStrFallback(&lk;, $langKey, $alternativeLabel)"/>
	</xsl:template>

	<!--
	template that adds an empty white space to the sides for table-style data
-->
	<xsl:template name="AddWhiteWidth">
		<xsl:param name="widthSpace" select="'10'"/>

		<td class="white_background" width="{$widthSpace}">
			<img src="images/clearpixel.gif" width="1" height="1" border="0"/>
		</td>
	</xsl:template>

	<!-- replace string 'str1' by other string 'str2'-->
<xsl:template name="replaceSubString">
		<xsl:param name="sourceString"/>
		<xsl:param name="str1"/>
		<xsl:param name="str2"/>
		<xsl:choose>
			<xsl:when test="contains($sourceString,$str1)">
				<xsl:value-of select="substring-before($sourceString,$str1)"/><xsl:value-of select="$str2"/><xsl:value-of select="substring-after($sourceString,$str1)"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$sourceString"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="ShowActionMenu"> 
		<xsl:param name="menuName" select="'menu1'"/>
		<xsl:param name="menuMinWidth" select="''"/>
		<xsl:param name="initialSpacing" select="'&nbsp;&nbsp;&nbsp;&nbsp;'"/>

		<xsl:value-of select="$initialSpacing"/>
		<a class="ActionLink" href="" onClick="return clickreturnvalue(event)" onMouseover="dropdownmenu(this, event, {$menuName}, '{$menuMinWidth}', true)" onMouseout="delayhidemenu()">
			<xsl:value-of select="Lang:getStr(&lk;,'ACTIONS')"/><span style="font-size:7px; font-style: normal; padding-left:2px">&#x25bc;</span> <!-- down-pointing arrow char -->
			<!--  <span style="font-style: normal;">&#x25be;</span> --> <!--  small down-pointing arrow -->
			<!--  &nbsp;<span class="ActionLinkArrow"/> --> <!-- CSS arrow: problems with positioning in IE7 -->
			<!-- xsl:value-of select="Lang:getStr(&lk;,'ACTIONS')"/>&nbsp;<img src="images/pulldown-button.png" border="0"/-->
			<!-- pulldown-button.png before: button_actions1.png, button style: button_actions.png --> <!-- Action arrow icons -->
		</a>				 					
	</xsl:template>

	<xsl:template name="FormatFileSize">
		<xsl:param name="filesize"/>

		<xsl:variable name="filesizeKB" select="$filesize*0.0009765625"/>

		<!-- show as KB if filesize if between 0 and 1024 KB -->
		<xsl:if test="($filesizeKB &gt; 0) and (($filesizeKB &lt; 1024)) ">
			<xsl:value-of select='format-number($filesizeKB,"###.#")'/>
			<xsl:value-of select="'KB'"/>
		</xsl:if>

		<!-- show as MB if filesize if between 1 and 1024 MB -->
		<xsl:if test="($filesizeKB &gt;= 1024) and (($filesizeKB &lt; (1024*1024))) ">
			<xsl:value-of select='format-number($filesizeKB * 0.0009765625,"###.#")'/>
			<xsl:value-of select="'MB'"/>
		</xsl:if>

		<!-- show as GB if filesize larger than or equal to 1024 MB -->
		<xsl:if test=" (($filesizeKB &gt;= (1024*1024))) ">
			<xsl:value-of select='format-number($filesizeKB * 0.0009765625 * 0.0009765625,"###.#")'/>
			<xsl:value-of select="'GB'"/>
		</xsl:if>
	</xsl:template>
	
	<!-- Used to write a Document Version information in the UI - this includes the Revision letter, if supplied
		Expected format: 
			- simple > $Version ($Revision_letter)
			- verbal > Version $Version Revision $Revision_letter
	 -->
	<xsl:template name="DocVersionRevisionLabel">
		<xsl:param name="version"/>
		<xsl:param name="revisionLetter" select="''"/>
		<xsl:param name="verbal" select="false()"/>

		<xsl:choose>
			<xsl:when test="not(boolean($verbal))">
				<!-- Simple Output mode -->
				<xsl:value-of select="$version"/><xsl:if test="string-length($revisionLetter) &gt; 0">&nbsp;(<xsl:value-of select="$revisionLetter"/>)</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<!-- Verbal Output mode -->
				<xsl:value-of select="Lang:getStr(&lk;,'VERSION')"/>&nbsp;<xsl:value-of select="$version"/><xsl:if test="string-length($revisionLetter) &gt; 0">&nbsp;<xsl:value-of select="Lang:getStr(&lk;,'REVISION')"/>&nbsp;<xsl:value-of select="$revisionLetter"/></xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
</xsl:stylesheet>